/*
 * Copyright 2004,2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.carbon.bridge;

import javax.servlet.ServletConfig;

/**
 * TODO:
 */
public class FrameworkLauncherFactory {

    private static FrameworkLauncher frameworkLauncher;

    public static FrameworkLauncher getFrameworkLauncher(){
        return frameworkLauncher;
    }

    public static FrameworkLauncher getFrameworkLauncher(ServletConfig servletConfig) throws Exception {
        String osgiFramework = servletConfig.getInitParameter("osgiFramework");
        if (osgiFramework == null || osgiFramework.length() == 0) {
            frameworkLauncher = new FelixFrameworkLauncher();
        } else if ("felix".equalsIgnoreCase(osgiFramework.trim())) {
            frameworkLauncher = new FelixFrameworkLauncher();
        } else if ("equinox".equalsIgnoreCase(osgiFramework.trim())) {
            frameworkLauncher = new EquinoxFrameworkLauncher();
        } else if ("knopflerfish".equalsIgnoreCase(osgiFramework.trim())) {
            frameworkLauncher = new KnopflerfishFrameworkLauncher();
        } else {
            throw new Exception(osgiFramework + "is not supported");
        }
        return frameworkLauncher;
    }
}
