package org.wso2.carbon.ui;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.osgi.framework.Bundle;
import org.wso2.carbon.ui.action.ActionHelper;

public class TilesJspServlet extends JspServlet {
	private static final long serialVersionUID = 1L;
	private static Log log = LogFactory.getLog(TilesJspServlet.class);

    public TilesJspServlet(Bundle bundle, String bundleResourcePath) {
        super(bundle, bundleResourcePath);
    }

    public void service(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String actionUrl = request.getRequestURI();

        //This is the layout page defined in
        //"/org.wso2.carbon.component/src/main/resources/web/WEB-INF/tiles/main_defs.xml"
        //Need to serve http requests other than to tiles body page,
        //using the normal OSGi way

        if ((actionUrl.lastIndexOf("/admin/layout/template.jsp") > -1)
                || actionUrl.lastIndexOf("ajaxprocessor.jsp") > -1) {
            super.service(request, response);
        } else if (actionUrl.startsWith("/carbon/registry/web/resources/foo/bar")) {
            //TODO : consider the renamed ROOT war scenario
            String resourcePath = actionUrl.replaceFirst("/carbon/registry/web/", "");
            String pathToRegistry = "path=" + resourcePath;
            if (log.isTraceEnabled()) {
                log.trace("Forwarding to registry : " + pathToRegistry);
            }
            RequestDispatcher dispatcher = request.getRequestDispatcher("../registry/registry-web.jsp?" + pathToRegistry);
            dispatcher.forward(request, response);
        } else {
            try {
                if (log.isDebugEnabled()) {
                    log.debug("request.getContextPath() : " + request.getContextPath());
                    log.debug("actionUrl : " + actionUrl);
                }
                String newPath = actionUrl.replaceFirst(request.getContextPath(), "");
                ActionHelper.render(newPath, request, response);
            } catch (Exception e) {
                log.fatal("Fatal error occurred while rendering UI using Tiles.", e);
            }
        }
    }
}
