package org.wso2.carbon.user.core.dbcreators;

import javax.sql.DataSource;

import org.wso2.carbon.user.core.def.DefaultRealm;
import org.wso2.carbon.user.core.hybrid.HybridRealm;


public class DBCreatorFactory {
    
    public DatabaseCreator getDatabaseCreator(String dialect, DataSource dataSource) throws Exception{
        DatabaseCreator creator = null;

        if(dialect.equals("derby")){
            creator = new DerbyDatabaseCreator(dataSource);
        }else if(dialect.equals("oracle")){
            creator = new OracleDatabaseCreator(dataSource);
        }else if(dialect.equals("mysql")){
            creator = new MySQLDatabaseCreator(dataSource);
        }else if(dialect.equals("hsql")){
            creator = new MySQLDatabaseCreator(dataSource);
        }else if(dialect.equals("sqlserver")){
            creator = new MSSQLDatabaseCreator(dataSource);
        }else if(dialect.equals("H2")){
            creator = new H2DatabaseCreator(dataSource);
        }else{
            throw new Exception("Unknown dialect");
        }
        return creator;
    }

}
